require "defines"

game.oninit(function()
	--startingItems()
	initTables()
end)


game.onload(function()
	initTables()
end)


game.onevent(defines.events.onentitydied, function(event)
end)


game.onevent(defines.events.onplayermineditem, function(event)
end)


game.onevent(defines.events.onbuiltentity, function(event)
	if event.createdentity.name == "resource-monitor" then
		local pos ={x = event.createdentity.position.x, y = event.createdentity.position.y}
		local ent = game.findentitiesfiltered{area = {{pos.x, pos.y}, {pos.x, pos.y}}, type="resource"}
		if (#ent > 0) and ((ent[1].prototype.resourcecategory == "basic-solid") or (isInSolidList(ent[1].prototype.resourcecategory))) then
			if game.player.gui.left.monitorFrame ~= nil then game.player.gui.left.monitorFrame.destroy() end
			if game.player.gui.left.resourceMonitorMinimized ~= nil then game.player.gui.left.resourceMonitorMinimized.destroy() end
			glob.resourceMonitor.flags.MonitorVisible = 0
			addMonitor(pos, ent[1].name)
		elseif (#ent > 0) and ((ent[1].prototype.resourcecategory == "basic-fluid") or (isInLiquidList(ent[1].prototype.resourcecategory))) then
			if game.player.gui.left.monitorFrame ~= nil then game.player.gui.left.monitorFrame.destroy() end
			if game.player.gui.left.resourceMonitorMinimized ~= nil then game.player.gui.left.resourceMonitorMinimized.destroy() end
			glob.resourceMonitor.flags.MonitorVisible = 0
			oilAdder(ent[1])
		else
			if glob.resourceMonitor.flags.AdderVisible ~= 1 then
				glob.resourceMonitor.flags.MonitorVisible = 1
				showMonitorGUI()
			end
		end
		game.player.insert{name = "resource-monitor", count = 1}
		event.createdentity.destroy()
	end
end)


game.onevent(defines.events.ontick, function(event)
	if game.tick % glob.resourceMonitor.flags.updateFreq == 11 then
		updateMonitorValues()
		showMonitorGUI()
	end
end)


game.onevent(defines.events.onguiclick, function(event)
	if event.element.name == "addButton" then
		glob.resourceMonitor.sites[#glob.resourceMonitor.sites + 1] = {}
		glob.resourceMonitor.sites[#glob.resourceMonitor.sites].name = game.player.gui.left.resourceMonitorAddingFrame.infoTable.siteNameText.text
		glob.resourceMonitor.sites[#glob.resourceMonitor.sites].initialAmount = glob.resourceMonitor.tmpSite.amount
		glob.resourceMonitor.sites[#glob.resourceMonitor.sites].amount = glob.resourceMonitor.tmpSite.amount
		glob.resourceMonitor.sites[#glob.resourceMonitor.sites].resourceType = glob.resourceMonitor.tmpSite.resourceType

		glob.resourceMonitor.sites[#glob.resourceMonitor.sites].oreDeposits = {}
		for i,k in ipairs(glob.resourceMonitor.tmpSite.oreDeposits) do
			glob.resourceMonitor.sites[#glob.resourceMonitor.sites].oreDeposits[i]= {x = k.x, y = k.y}
		end
		for _,overlay in ipairs(glob.resourceMonitor.overlayStack) do
			if overlay.valid then
				overlay.destroy()
			end
		end
		glob.resourceMonitor.overlayStack = {}
		glob.resourceMonitor.tmpSite.oreDeposits = {}
		game.player.gui.left.resourceMonitorAddingFrame.destroy()
		glob.resourceMonitor.flags.AdderVisible = 0
		glob.resourceMonitor.flags.MonitorVisible = 1
		showMonitorGUI()
	elseif event.element.name == "cancelAddButton" then
		for _,overlay in ipairs(glob.resourceMonitor.overlayStack) do
			if overlay.valid then
				overlay.destroy()
			end
		end
		glob.resourceMonitor.overlayStack = {}
		game.player.gui.left.resourceMonitorAddingFrame.destroy()
		glob.resourceMonitor.flags.AdderVisible = 0
		glob.resourceMonitor.flags.MonitorVisible = 1
		showMonitorGUI()
	elseif event.element.name == "minButton" then
		game.player.gui.left.monitorFrame.destroy()
		glob.resourceMonitor.flags.MonitorVisible = 2
		showMonitorGUI()
	elseif event.element.name == "resourceMonitorMinimized" then
		game.player.gui.left.resourceMonitorMinimized.destroy()
		glob.resourceMonitor.flags.MonitorVisible = 1
		showMonitorGUI()
	elseif event.element.name == "monitorClose" then
		game.player.gui.left.monitorFrame.destroy()
		glob.resourceMonitor.flags.MonitorVisible = 0
	elseif event.element.name == "settingsButton" then
		game.player.gui.left.monitorFrame.destroy()
		glob.resourceMonitor.flags.MonitorVisible = 0
		glob.resourceMonitor.flags.SettingsVisible = 1
		showSettingsGUI()
	elseif event.element.name == "settingsYesButton" then
		if game.player.gui.left.settingsFrame.settingsTable.showTypeBox.state == true then
			glob.resourceMonitor.flags.ShowType = 1
		else
			glob.resourceMonitor.flags.ShowType = 0
		end
		if game.player.gui.left.settingsFrame.settingsTable.showAmountBox.state == true then
			glob.resourceMonitor.flags.ShowAmount = 1
		else
			glob.resourceMonitor.flags.ShowAmount = 0
		end
		if game.player.gui.left.settingsFrame.settingsTable.showRemoveBox.state == true then
			glob.resourceMonitor.flags.ShowRemove = 1
		else
			glob.resourceMonitor.flags.ShowRemove = 0
		end
		if game.player.gui.left.settingsFrame.settingsTable.showDeltaBox.state == true then
			glob.resourceMonitor.flags.ShowDelta = 1
		else
			glob.resourceMonitor.flags.ShowDelta = 0
		end
		if game.player.gui.left.settingsFrame.settingsTable.showNotificationBox.state == true then
			glob.resourceMonitor.flags.ShowNotification = 1
		else
			glob.resourceMonitor.flags.ShowNotification = 0
		end
		if game.player.gui.left.settingsFrame.settingsTable.showNotificationBox2.state == true then
			glob.resourceMonitor.flags.ShowNotification2 = 1
		else
			glob.resourceMonitor.flags.ShowNotification2 = 0
		end
		if game.player.gui.left.settingsFrame.settingsUpdateFrame.settingsUpdateTable.updateBox1.state == true then
			if glob.resourceMonitor.flags.updateFreq ~= 600 then
				glob.resourceMonitor.flags.updateFreq = 600
			end
		elseif game.player.gui.left.settingsFrame.settingsUpdateFrame.settingsUpdateTable.updateBox2.state == true then
			if glob.resourceMonitor.flags.updateFreq ~= 1800 then
				glob.resourceMonitor.flags.updateFreq = 1800
			end
		elseif game.player.gui.left.settingsFrame.settingsUpdateFrame.settingsUpdateTable.updateBox3.state == true then
			if glob.resourceMonitor.flags.updateFreq ~= 3600 then
				glob.resourceMonitor.flags.updateFreq = 3600
			end
		end
		game.player.gui.left.settingsFrame.destroy()
		glob.resourceMonitor.flags.MonitorVisible = 1
		glob.resourceMonitor.flags.SettingsVisible = 0
		showMonitorGUI()
	elseif event.element.name == "settingsCancelButton" then
		game.player.gui.left.settingsFrame.destroy()
		glob.resourceMonitor.flags.MonitorVisible = 1
		glob.resourceMonitor.flags.SettingsVisible = 0
		showMonitorGUI()
	elseif string.find (event.element.name, "monitorRemoveButton") ~= nil then
		local txt, cnt = string.gsub (event.element.name, "monitorRemoveButton" , "")
		table.remove(glob.resourceMonitor.sites, txt)
		showMonitorGUI()
	elseif event.element.name == "updateBox1" then
		game.player.gui.left.settingsFrame.settingsUpdateFrame.settingsUpdateTable.updateBox2.state = not event.element.state
		game.player.gui.left.settingsFrame.settingsUpdateFrame.settingsUpdateTable.updateBox3.state = not event.element.state
	elseif event.element.name == "updateBox2" then
		game.player.gui.left.settingsFrame.settingsUpdateFrame.settingsUpdateTable.updateBox1.state = not event.element.state
		game.player.gui.left.settingsFrame.settingsUpdateFrame.settingsUpdateTable.updateBox3.state = not event.element.state
	elseif event.element.name == "updateBox3" then
		game.player.gui.left.settingsFrame.settingsUpdateFrame.settingsUpdateTable.updateBox1.state = not event.element.state
		game.player.gui.left.settingsFrame.settingsUpdateFrame.settingsUpdateTable.updateBox2.state = not event.element.state
	elseif event.element.name == "newOilAddButton" then
		glob.resourceMonitor.oil[#glob.resourceMonitor.oil + 1] = {}
		glob.resourceMonitor.oil[#glob.resourceMonitor.oil].name = game.player.gui.left.oilMonitorAddingFrame.infoTable.siteNameText.text
		glob.resourceMonitor.oil[#glob.resourceMonitor.oil].type = glob.resourceMonitor.tmpOil.name
		glob.resourceMonitor.oil[#glob.resourceMonitor.oil].entity = {}
		glob.resourceMonitor.oil[#glob.resourceMonitor.oil].entity[1] = glob.resourceMonitor.tmpOil
		game.player.gui.left.oilMonitorAddingFrame.destroy()
		glob.resourceMonitor.flags.AdderVisible = 0
		glob.resourceMonitor.flags.MonitorVisible = 1
		showMonitorGUI()
	elseif event.element.name == "newOilExistButton" then
		if #glob.resourceMonitor.oil > 0 then
			oilAdderExpansion()
		else
			game.player.print({"noOilLabel"})
		end
	elseif event.element.name == "newOreExistButton" then
		if #glob.resourceMonitor.sites > 0 then
			oreAdderExpansion()
		else
			game.player.print({"noOreLabel"})
		end
	elseif string.find (event.element.name, "oilAddExistButton") ~= nil then
		local txt, cnt = string.gsub (event.element.name, "oilAddExistButton" , "")
		txt = tonumber(txt)
		local tmpFlag = false
		for i,_ in ipairs(glob.resourceMonitor.oil[txt].entity) do
			if glob.resourceMonitor.oil[txt].entity[i].equals(glob.resourceMonitor.tmpOil) then
				tmpFlag = true
			end
		end
		if tmpFlag == false then
			table.insert(glob.resourceMonitor.oil[txt].entity, glob.resourceMonitor.tmpOil)
			game.player.gui.left.oilMonitorAddingFrame.destroy()
			glob.resourceMonitor.flags.AdderVisible = 0
			glob.resourceMonitor.flags.MonitorVisible = 1
			showMonitorGUI()
		else
			game.player.print({"oilwellalreadypresent"})
		end
	elseif string.find (event.element.name, "oreAddExistButton") ~= nil then
		local txt, cnt = string.gsub (event.element.name, "oreAddExistButton" , "")
		txt = tonumber(txt)
		local deposits = {}
		for _,newDeposit in ipairs(glob.resourceMonitor.tmpSite.oreDeposits) do
			local tmpFlag = false
			for _,existingDeposit in ipairs(glob.resourceMonitor.sites[txt].oreDeposits) do
				if (newDeposit.x == existingDeposit.x) and (newDeposit.y == existingDeposit.y) then
					tmpFlag = true
				end
			end
			if tmpFlag == false then table.insert(deposits, newDeposit) end
		end
		if #deposits > 0 then
			for i,_ in ipairs(deposits) do
				table.insert(glob.resourceMonitor.sites[txt].oreDeposits, deposits[i])
			end
		else
			game.player.print({"oreDepositalreadypresent"})
		end
		for _,overlay in ipairs(glob.resourceMonitor.overlayStack) do
			if overlay.valid then
				overlay.destroy()
			end
		end
		glob.resourceMonitor.tmpSite.oreDeposits = {}
		game.player.gui.left.resourceMonitorAddingFrame.destroy()
		glob.resourceMonitor.flags.AdderVisible = 0
		glob.resourceMonitor.flags.MonitorVisible = 1
		updateMonitorValues()
		showMonitorGUI()
		
	elseif event.element.name == "oilCancelAddButton" then
		game.player.gui.left.oilMonitorAddingFrame.destroy()
		glob.resourceMonitor.flags.AdderVisible = 0
		glob.resourceMonitor.flags.MonitorVisible = 1
		showMonitorGUI()
	elseif string.find (event.element.name, "oilMonitorRemoveButton") ~= nil then
		local txt, cnt = string.gsub (event.element.name, "oilMonitorRemoveButton" , "")
		table.remove(glob.resourceMonitor.oil, txt)
		showMonitorGUI()
	elseif event.element.name == "switchMode" then
			local elementCaption = tostring(event.element.caption[1])
			local testCaption = "modeButtonResource"
		if elementCaption == testCaption then
			glob.resourceMonitor.flags.ShowResource = 0
			glob.resourceMonitor.flags.ShowOil = 1
		else
			glob.resourceMonitor.flags.ShowResource = 1
			glob.resourceMonitor.flags.ShowOil = 0
		end
		showMonitorGUI()
	end
end)


function updateMonitorValues()
	for _, monitor in ipairs(glob.resourceMonitor.sites) do
		if type(monitor.amount) ~= type(42) then
			if glob.resourceMonitor.flags.ShowNotification == 1 then
				game.player.print({"depletedNotification"})
			end
		else
			local amount = 0
			for _, pos in ipairs(monitor.oreDeposits) do
				local tmpDeposit = game.findentitiesfiltered{area = {pos, pos}, name = monitor.resourceType}
				if tmpDeposit[1] ~= nil then
					amount = amount + tmpDeposit[1].amount
				end
			end

			if monitor.oldAmount == nil then
				monitor.oldAmount = amount
				monitor.deltaAmount = {0,0,0,0,0,0,0}
			end

			if amount == 0 then
				monitor.amount = {"depleted"}
				if glob.resourceMonitor.flags.ShowNotification == 1 then
					game.player.print({"depletedNotification"})
				end
			else
				monitor.amount = amount
			end

			if type(monitor.amount) == type(42) then
				local newDelta = (monitor.oldAmount - monitor.amount) * (3600 / glob.resourceMonitor.flags.updateFreq)
				if newDelta >= 0 then
					table.remove(monitor.deltaAmount,2)
					table.insert(monitor.deltaAmount, newDelta)
				end
				local deltaSum = 0
				for k, value in ipairs(monitor.deltaAmount) do
					if k ~= 1 then
						deltaSum = deltaSum + value
					end
				end
				monitor.deltaAmount[1] = math.floor(deltaSum / 6)
				if (monitor.maxdelta == nil) then
					monitor.maxdelta = 0
				end 
				if (monitor.deltaAmount[1] ~= nil) and (type(monitor.deltaAmount[1]) == type(42)) then
					if monitor.deltaAmount[1] > monitor.maxdelta then
						monitor.maxdelta = monitor.deltaAmount[1]
					end
				end
				if glob.resourceMonitor.flags.ShowNotification2 == 1 then
					if monitor.amount <= monitor.initialAmount / 10 then
						game.player.print({"nearlyDepletedNotification"})
					end
				end
			else
				monitor.deltaAmount[1] = {"na"}
			end

			monitor.oldAmount = monitor.amount
		end
	end
end


function initTables()

	if glob.resourceMonitor == nil then
		glob.resourceMonitor = {}
	end

		if glob.resourceMonitor.flags == nil then
			glob.resourceMonitor.flags = {}
		end

			if glob.resourceMonitor.flags.MonitorVisible == nil then
				glob.resourceMonitor.flags.MonitorVisible = 0	-- 0 = not visible
																-- 1 = GUI visible
																-- 2 = GUI minimized
			end
			
			if glob.resourceMonitor.flags.AdderVisible == nil then	
				glob.resourceMonitor.flags.AdderVisible = 0		-- 0 = not visible
																-- 1 = GUI visible
			end

			if glob.resourceMonitor.flags.SettingsVisible == nil then
				glob.resourceMonitor.flags.SettingsVisible = 0	-- 0 = not visible
																-- 1 = GUI visible
			end

			if glob.resourceMonitor.flags.ShowType == nil then
				glob.resourceMonitor.flags.ShowType = 1			-- 0 = not visible
																-- 1 = element visible
			end

			if glob.resourceMonitor.flags.ShowAmount == nil then
				glob.resourceMonitor.flags.ShowAmount = 1		-- 0 = not visible
																-- 1 = element visible
			end

			if glob.resourceMonitor.flags.ShowRemove == nil then
				glob.resourceMonitor.flags.ShowRemove = 1		-- 0 = not visible
																-- 1 = element visible
			end

			if glob.resourceMonitor.flags.ShowDelta == nil then
				glob.resourceMonitor.flags.ShowDelta = 1		-- 0 = not visible
																-- 1 = element visible
			end

			if glob.resourceMonitor.flags.ShowNotification == nil then
				glob.resourceMonitor.flags.ShowNotification = 1 -- 0 = no messages
																-- 1 = show messages
			end

			if glob.resourceMonitor.flags.ShowNotification2 == nil then
				glob.resourceMonitor.flags.ShowNotification2 = 1 -- 0 = no 10% messages
																-- 1 = show 10% messages
			end

			if glob.resourceMonitor.flags.ShowResource == nil then
				glob.resourceMonitor.flags.ShowResource = 1 	-- 0 = no visible
																-- 1 = visible
			end

			if glob.resourceMonitor.flags.ShowOil == nil then
				glob.resourceMonitor.flags.ShowOil = 0 			-- 0 = not visible
																-- 1 = visible
			end

			if glob.resourceMonitor.flags.updateFreq == nil then
				glob.resourceMonitor.flags.updateFreq = 600		-- in ticks
			end

		if glob.resourceMonitor.sites == nil then
			glob.resourceMonitor.sites = {}
		else
			for _, deposit in ipairs(glob.resourceMonitor.sites) do
				if deposit.initialAmount == nil then
					deposit.initialAmount = deposit.amount
				end
			end
		end

		if glob.resourceMonitor.tmpSite == nil then
			glob.resourceMonitor.tmpSite = {amount, resourceType, oreDeposits = {}}
		end

		if glob.resourceMonitor.overlayStack == nil then
			glob.resourceMonitor.overlayStack = {}
		end

		if glob.resourceMonitor.oil == nil then
			glob.resourceMonitor.oil = {}
			glob.resourceMonitor.flags.ShowResource = 1 
			glob.resourceMonitor.flags.ShowOil = 1
		else
			if #glob.resourceMonitor.oil > 0 then
				for _,oilMonitor in ipairs(glob.resourceMonitor.oil) do
					if oilMonitor.type == nil then
						oilMonitor.type = oilMonitor.entity[1].name
					end
				end
			end
		end

		if glob.resourceMonitor.tmpOil == nil then
			glob.resourceMonitor.tmpOil = {}
		end

		if glob.resourceMonitor.resourceSolidList == nil then
			glob.resourceMonitor.resourceSolidList = {}
		end

		if glob.resourceMonitor.resourceLiquidList == nil then
			glob.resourceMonitor.resourceLiquidList = {}
		end

	glob.resourceMonitor.version = "0.4.1"
end


function showMonitorGUI()
	if glob.resourceMonitor.flags.MonitorVisible == 1 then
		if game.player.gui.left.monitorFrame ~= nil then game.player.gui.left.monitorFrame.destroy() end
		local rootFrame = game.player.gui.left.add{type = "frame", name = "monitorFrame", caption = {"monitorCaption"}, direction = "vertical"}
		rootFrame.add{type = "flow", name = "monitorFlow", direction = "horizontal"}
		rootFrame.monitorFlow.add{type = "button", name = "minButton", caption = {"minButtonCaption"}, style = "smallerButtonFont"}
		local modeButtonCaption = 0
		if glob.resourceMonitor.flags.ShowResource == 1 then
			glob.resourceMonitor.flags.ShowOil = 0
			modeButtonCaption = {"modeButtonResource"}
		else
			glob.resourceMonitor.flags.ShowResource = 0
			glob.resourceMonitor.flags.ShowOil = 1
			modeButtonCaption = {"modeButtonOil"}
		end
		rootFrame.monitorFlow.add{type = "button", name = "switchMode", caption = modeButtonCaption, style = "smallerButtonFont"}
		rootFrame.monitorFlow.add{type = "button", name = "settingsButton", caption = {"settingsButtonCaption"}, style = "smallerButtonFont"}
		rootFrame.monitorFlow.add{type = "button", name = "monitorClose", caption = {"monitorClose"}, style = "smallerButtonFont"}

		local opt = glob.resourceMonitor.flags
		if (#glob.resourceMonitor.sites > 0) and (opt.ShowResource == 1) then
			local sum = 1 + opt.ShowType + opt.ShowAmount + opt.ShowRemove + opt.ShowDelta
			local resFrame = rootFrame.add{type ="frame", name = "resMonitorTable", caption = {"ores"}}
			resFrame.add{type ="table", name = "monitorTable", colspan = sum}
				resFrame.monitorTable.add{type = "label", name = "siteNameLabelHead", caption = {"siteNameLabel"}}
				if opt.ShowType == 1 then
					resFrame.monitorTable.add{type = "label", name = "siteTypeLabelHead", caption = {"resTypeLabel"}}
				end
				if opt.ShowAmount == 1 then
					resFrame.monitorTable.add{type = "label", name = "siteAmountLabelHead", caption = {"resAmountLabel"}}
				end
				if opt.ShowDelta == 1 then
					resFrame.monitorTable.add{type = "label", name = "siteDeltaLabelHead", caption = {"siteDeltaLabelHead"}}
				end
				if opt.ShowRemove == 1 then
					resFrame.monitorTable.add{type = "label", name = "monitorDummy", caption = " "}
				end
				for i,k in ipairs(glob.resourceMonitor.sites) do
					resFrame.monitorTable.add{type = "label", name = "siteNameLabel"..i, caption = k.name}
					if opt.ShowType == 1 then
						resFrame.monitorTable.add{type = "label", name = "siteTypeLabel"..i, caption = game.getlocalisedentityname(k.resourceType)}
					end
					if opt.ShowAmount == 1 then
						resFrame.monitorTable.add{type = "label", name = "siteAmountLabel"..i, caption = "  "}
						if type(k.amount) ~= type(42) then
							resFrame.monitorTable["siteAmountLabel"..i].caption = k.amount
							resFrame.monitorTable["siteAmountLabel"..i].style.fontcolor = {r = 1, g = 0, b = 0}
						else
							local formattedAmount = formatAmount(k.amount)
							local color = {r = 1, g = 1, b = 0}
							if k.amount >= k.initialAmount / 2 then
								color.g = 1
								color.r = (1 - (k.amount / k.initialAmount)) * 2
							else
								color.r = 1
								color.g = 2 * (k.amount / k.initialAmount)
							end
							resFrame.monitorTable["siteAmountLabel"..i].style.fontcolor = color
							resFrame.monitorTable["siteAmountLabel"..i].caption = "  " ..formattedAmount
						end
					end
					if opt.ShowDelta == 1 then
						local delta = 0
						if k.deltaAmount ~= nil then
							delta = k.deltaAmount[1]
						end
						local mdelta = 0
						if k.maxdelta ~= nil then
							mdelta = k.maxdelta
						end
						resFrame.monitorTable.add{type = "label", name = "siteDeltaLabel"..i, caption = " "}
						if (type(delta) ~= type(42)) or (delta == 0) then
							resFrame.monitorTable["siteDeltaLabel"..i].caption = delta
							resFrame.monitorTable["siteDeltaLabel"..i].style.fontcolor = {r = 1, g = 0, b = 0}
						elseif mdelta ~= 0 then
							local color = {r = 1, g = 1, b = 0}
							if delta >= mdelta / 2 then
								color.g = 1
								color.r = (1 - (delta / mdelta)) * 2
							else
								color.r = 1
								color.g = 2 * (delta / mdelta)
							end
							resFrame.monitorTable["siteDeltaLabel"..i].style.fontcolor = color
							resFrame.monitorTable["siteDeltaLabel"..i].caption = formatAmount(delta)
						end
					end
					if opt.ShowRemove == 1 then
						resFrame.monitorTable.add{type = "button", name = "monitorRemoveButton"..i, caption = {"monitorRemoveButtonCaption"}, style = "smallerButtonFont"}
					end
				end
		elseif (opt.ShowResource == 1) then
			rootFrame.add{type = "label", name = "noSiteLabel", caption = {"noSiteLabel"}}
		end

		if (#glob.resourceMonitor.oil > 0) and (opt.ShowOil == 1) then
			local span = 3 + opt.ShowRemove + opt.ShowType
			local oilFrame = rootFrame.add{type ="frame", name = "oilMonitorTable", caption = {"oil"}}
			oilFrame.add{type ="table", name = "oilMonitorTable", colspan = span}
				oilFrame.oilMonitorTable.add{type = "label", name = "oilSiteNameLabelHead", caption = {"siteNameLabel"}}
				if opt.ShowType == 1 then
					oilFrame.oilMonitorTable.add{type = "label", name = "oilSiteTypeLabelHead", caption = {"oilTypeLabel"}}
				end
				oilFrame.oilMonitorTable.add{type = "label", name = "oilSiteYieldLabelHead", caption = {"oilSiteYieldLabelHead"}}
				local oilSiteNumberLabelHeadCaption = 
				oilFrame.oilMonitorTable.add{type = "label", name = "oilSiteNumberLabelHead", caption = {"noOilWells"}}
				if opt.ShowRemove == 1 then
					oilFrame.oilMonitorTable.add{type = "label", name = "monitorDummy", caption = "  "}
				end
			for i,oilMonitor in ipairs(glob.resourceMonitor.oil) do
				oilFrame.oilMonitorTable.add{type = "label", name = "oilSiteNameLabel"..i, caption = oilMonitor.name}
				if opt.ShowType == 1 then
					oilFrame.oilMonitorTable.add{type = "label", name = "oilSiteTypeLabel"..i, caption = game.getlocalisedentityname(oilMonitor.type)}
				end
				local tmpYield = 0
				for _,oilEnt in ipairs(oilMonitor.entity) do
					tmpYield = tmpYield + (oilEnt.amount / 750*10)
				end
				tmpYield = formatAmount(math.floor(tmpYield)) .."%"
				oilFrame.oilMonitorTable.add{type = "label", name = "oilSiteYieldLabel"..i, caption = "  " ..tmpYield}
				oilFrame.oilMonitorTable.add{type = "label", name = "oilSiteNumberLabel"..i, caption = "     " ..#oilMonitor.entity}
				if opt.ShowRemove == 1 then
					oilFrame.oilMonitorTable.add{type = "button", name = "oilMonitorRemoveButton"..i, caption = {"monitorRemoveButtonCaption"}, style = "smallerButtonFont"}
				end

			end
		elseif (opt.ShowOil == 1) then
			rootFrame.add{type = "label", name = "noOilLabel", caption = {"noOilLabel"}}
		end
		
	elseif glob.resourceMonitor.flags.MonitorVisible == 2 then
		if game.player.gui.left.monitorFrame ~= nil then game.player.gui.left.monitorFrame.destroy() end
		if game.player.gui.left.resourceMonitorMinimized ~= nil then game.player.gui.left.resourceMonitorMinimized.destroy() end
		game.player.gui.left.add{type="button", name="resourceMonitorMinimized", caption="R"}
		game.player.gui.left.resourceMonitorMinimized.style.fontcolor = {r = 0, b = 0, g = 1}
	elseif glob.resourceMonitor.flags.MonitorVisible == 0 then
		-- do nothing
	end
end


function addMonitor(startingPosition,resType)
	if glob.resourceMonitor.flags.AdderVisible == 1 then
		game.player.print({"addingFrameIsAlreadyOpen"})
		return
	end
	if glob.resourceMonitor.flags.SettingsVisible == 1 then
		game.player.print({"settingsFrameIsOpen"})
		return
	end

	local tmpResType = resType
	local oreDeposit = getInitialResources(startingPosition, resType)
	local tmpAmount = 0 

	for _, tmpPos in ipairs(oreDeposit) do
		local tmpTile = game.findentitiesfiltered{area = {tmpPos, tmpPos}, name = resType}
		tmpAmount = tmpAmount + tmpTile[1].amount
		local overlay = game.createentity{name="rm_overlay", position = tmpPos}
			overlay.minable = false
			overlay.destructible = false
		if glob.resourceMonitor.overlayStack == nil then glob.resourceMonitor.overlayStack = {} end
		table.insert(glob.resourceMonitor.overlayStack, overlay)
	end

	local tmpName = "Monitor" ..(#glob.resourceMonitor.sites + 1)

	local rootAddingFrame = game.player.gui.left.add{type = "frame", name = "resourceMonitorAddingFrame", caption = {"addingFrameCaption"}, direction = "vertical"}
		rootAddingFrame.add{type ="table", name = "infoTable", colspan = 2}
			rootAddingFrame.infoTable.add{type = "label", name = "siteNameLabel", caption = {"siteNameLabel"}}
			rootAddingFrame.infoTable.add{type = "textfield", name = "siteNameText"}
				rootAddingFrame.infoTable.siteNameText.text = tmpName
				rootAddingFrame.infoTable.siteNameText.caption = tmpName
			rootAddingFrame.infoTable.add{type = "label", name = "resTypeLabel", caption = {"resTypeLabel"}}
			rootAddingFrame.infoTable.add{type = "label", name = "resTypeLabel2", caption = game.getlocalisedentityname(tmpResType)}
			rootAddingFrame.infoTable.add{type = "label", name = "resAmountLabel", caption = {"resAmountLabel"}}
			rootAddingFrame.infoTable.add{type = "label", name = "resAmountLabel2", caption = formatAmount(tmpAmount)}
		rootAddingFrame.add{type = "flow", name = "yesNoFlow", direction = "horizontal"}
			rootAddingFrame.yesNoFlow.add{type = "button", name = "addButton", caption = {"addButtonCaption"}}
			rootAddingFrame.yesNoFlow.add{type = "button", name = "cancelAddButton", caption = {"cancelButtonCaption"}}
		rootAddingFrame.add{type = "button", name = "newOreExistButton", caption = {"newExistButton"}}

	glob.resourceMonitor.tmpSite.amount = tmpAmount
	glob.resourceMonitor.tmpSite.resourceType = tmpResType
	for _,k in ipairs(oreDeposit) do
		glob.resourceMonitor.tmpSite.oreDeposits[#glob.resourceMonitor.tmpSite.oreDeposits + 1]= {x = k.x, y = k.y}
	end
	glob.resourceMonitor.flags.AdderVisible = 1
end


function oreAdderExpansion()
	if game.player.gui.left.resourceMonitorAddingFrame.addExistTable ~= nil then
		return
	end
	
	local existTable = game.player.gui.left.resourceMonitorAddingFrame.add{type = "table", name = "addExistTable", colspan = 3}
		existTable.add{type = "label", name = "oreSiteDummy1", caption = {"siteNameLabel"}}
		existTable.add{type = "label", name = "oreSiteDummy2", caption = {"resAmountLabel"}}
		existTable.add{type = "label", name = "oreSiteDummy3", caption = " "}
	for i,oreMonitor in ipairs(glob.resourceMonitor.sites) do
		if oreMonitor.resourceType == glob.resourceMonitor.tmpSite.resourceType then
			existTable.add{type = "label", name = "oreSiteNameLabel1"..i, caption = oreMonitor.name}
			if type(oreMonitor.amount) == type(42) then
				existTable.add{type = "label", name = "oreSiteNameLabel2"..i, caption = formatAmount(oreMonitor.amount)}
			else
				existTable.add{type = "label", name = "oreSiteNameLabel2"..i, caption = oreMonitor.amount}
			end
			existTable.add{type = "button", name = "oreAddExistButton"..i, caption = {"addButtonCaption"}, style = "smallerButtonFont"}
		end
	end
end


function oilAdder(oilEntity)
	if glob.resourceMonitor.flags.AdderVisible == 1 then
		game.player.print({"addingFrameIsAlreadyOpen"})
		return
	end
	if glob.resourceMonitor.flags.SettingsVisible == 1 then
		game.player.print({"settingsFrameIsOpen"})
		return
	end

	local tmpAmount = oilEntity.amount
	local tmpName = 0
	if glob.resourceMonitor.oil == nil then
		tmpName = "Liquid-Monitor1"
	else
		tmpName = "Liquid-Monitor" ..(#glob.resourceMonitor.oil + 1)
	end

	local rootOilAddingFrame = game.player.gui.left.add{type = "frame", name = "oilMonitorAddingFrame", caption = {"addingFrameCaption"}, direction = "vertical"}
		rootOilAddingFrame.add{type ="table", name = "infoTable", colspan = 2}
			rootOilAddingFrame.infoTable.add{type = "label", name = "siteNameLabel", caption = {"siteNameLabel"}}
			rootOilAddingFrame.infoTable.add{type = "textfield", name = "siteNameText"}
				rootOilAddingFrame.infoTable.siteNameText.text = tmpName
				rootOilAddingFrame.infoTable.siteNameText.caption = tmpName
			rootOilAddingFrame.infoTable.add{type = "label", name = "oilTypeLabel", caption = {"oilTypeLabel"}}
			rootOilAddingFrame.infoTable.add{type = "label", name = "oilTypeLabel2", caption = game.getlocalisedentityname(oilEntity.name)}
			rootOilAddingFrame.infoTable.add{type = "label", name = "oilYieldLabel", caption = {"oilYieldLabel"}}
			rootOilAddingFrame.infoTable.add{type = "label", name = "oilYieldLabel2", caption = formatAmount(math.floor(tmpAmount / 750*10)).."%"} -- 750 == min amount
			rootOilAddingFrame.infoTable.add{type = "label", name = "oilAmountLabel", caption = {"oilAmountLabel"}}
			rootOilAddingFrame.infoTable.add{type = "label", name = "oilAmountLabel2", caption = formatAmount(tmpAmount)}
		rootOilAddingFrame.add{type = "table", name = "yesNoFlow", colspan = 2}
			rootOilAddingFrame.yesNoFlow.add{type = "button", name = "newOilAddButton", caption = {"addNewOilButtonCaption"}}
			rootOilAddingFrame.yesNoFlow.add{type = "button", name = "oilCancelAddButton", caption = {"cancelButtonCaption"}}
		rootOilAddingFrame.add{type = "button", name = "newOilExistButton", caption = {"newExistButton"}}

	glob.resourceMonitor.tmpOil = oilEntity
	glob.resourceMonitor.flags.AdderVisible = 1
end


function oilAdderExpansion()
	local existTable = game.player.gui.left.oilMonitorAddingFrame.add{type = "table", name = "addExistTable", colspan = 3}
		existTable.add{type = "label", name = "oilSiteDummy1", caption = {"siteNameLabel"}}
		existTable.add{type = "label", name = "oilSiteDummy2", caption = {"noOilWells"}}
		existTable.add{type = "label", name = "oilSiteDummy3", caption = " "}
	for i,oilMonitor in ipairs(glob.resourceMonitor.oil) do
		if oilMonitor.type == glob.resourceMonitor.tmpOil.name then
			existTable.add{type = "label", name = "oilSiteNameLabel1"..i, caption = oilMonitor.name}
			existTable.add{type = "label", name = "oilSiteNameLabel2"..i, caption = "      "..#oilMonitor.entity}
			existTable.add{type = "button", name = "oilAddExistButton"..i, caption = {"addButtonCaption"}, style = "smallerButtonFont"}
		end
	end
end


function showSettingsGUI()
	local rootSettingsFrame = game.player.gui.left.add{type = "frame", name = "settingsFrame", caption = {"settingsCaption"}, direction = "vertical"}
			rootSettingsFrame.add{type ="table", name = "settingsTable", colspan = 2}
				rootSettingsFrame.settingsTable.add{type = "label", name = "showTypeLabel", caption = {"showTypeLabel"}}
				rootSettingsFrame.settingsTable.add{type = "checkbox", name = "showTypeBox", state = glob.resourceMonitor.flags.ShowType}
				rootSettingsFrame.settingsTable.add{type = "label", name = "showAmountLabel", caption = {"showAmountLabel"}}
				rootSettingsFrame.settingsTable.add{type = "checkbox", name = "showAmountBox", state = glob.resourceMonitor.flags.ShowAmount}
				rootSettingsFrame.settingsTable.add{type = "label", name = "showRemoveLabel", caption = {"showRemoveLabel"}}
				rootSettingsFrame.settingsTable.add{type = "checkbox", name = "showRemoveBox", state = glob.resourceMonitor.flags.ShowRemove}
				rootSettingsFrame.settingsTable.add{type = "label", name = "showDeltaLabel", caption = {"showDeltaLabel"}}
				rootSettingsFrame.settingsTable.add{type = "checkbox", name = "showDeltaBox", state = glob.resourceMonitor.flags.ShowDelta}
				rootSettingsFrame.settingsTable.add{type = "label", name = "showNotificationLabel2", caption = {"showNotificationLabel2"}}
				rootSettingsFrame.settingsTable.add{type = "checkbox", name = "showNotificationBox2", state = glob.resourceMonitor.flags.ShowNotification2}
				rootSettingsFrame.settingsTable.add{type = "label", name = "showNotificationLabel", caption = {"showNotificationLabel"}}
				rootSettingsFrame.settingsTable.add{type = "checkbox", name = "showNotificationBox", state = glob.resourceMonitor.flags.ShowNotification}

			rootSettingsFrame.add{type = "frame", name = "settingsUpdateFrame", direction = "horizontal", caption = {"settingsUpdateTableCaption"}}
				rootSettingsFrame.settingsUpdateFrame.add{type ="table", name = "settingsUpdateTable", colspan = 2}
					rootSettingsFrame.settingsUpdateFrame.settingsUpdateTable.add{type = "label", name = "updateLabel1", caption = {"updateLabel1"}}
					rootSettingsFrame.settingsUpdateFrame.settingsUpdateTable.add{type = "checkbox", name = "updateBox1", state = (glob.resourceMonitor.flags.updateFreq == 600)}
					rootSettingsFrame.settingsUpdateFrame.settingsUpdateTable.add{type = "label", name = "updateLabel2", caption = {"updateLabel2"}}
					rootSettingsFrame.settingsUpdateFrame.settingsUpdateTable.add{type = "checkbox", name = "updateBox2", state = (glob.resourceMonitor.flags.updateFreq == 1800)}
					rootSettingsFrame.settingsUpdateFrame.settingsUpdateTable.add{type = "label", name = "updateLabel3", caption = {"updateLabel3"}}
					rootSettingsFrame.settingsUpdateFrame.settingsUpdateTable.add{type = "checkbox", name = "updateBox3", state = (glob.resourceMonitor.flags.updateFreq == 3600)}

			rootSettingsFrame.add{type = "flow", name = "settingsFlow", direction = "horizontal"}
				rootSettingsFrame.settingsFlow.add{type = "button", name = "settingsYesButton", caption = {"settingsYesButton"}}
				rootSettingsFrame.settingsFlow.add{type = "button", name = "settingsCancelButton", caption = {"settingsCancelButton"}}
end


function getInitialResources(startPos, resType)
	local listA = {}
	local listB = {}
	local tmpPos = {x = startPos.x, y = startPos.y}
	local completeAmount = 0
	local tmpEntry = {}
	
	table.insert(listA, {x = tmpPos.x, y = tmpPos.y})

	while (#listA > 0) do
		tmpEntry = {x = listA[#listA].x, y = listA[#listA].y}
		table.remove(listA)
		table.insert(listB, tmpEntry)
		if checkTile({x = tmpEntry.x, y = tmpEntry.y - 1}, resType, listA, listB) == true then
			table.insert(listA, {x = tmpEntry.x, y = tmpEntry.y - 1})
		end
		if checkTile({x = tmpEntry.x, y = tmpEntry.y + 1}, resType, listA, listB) == true then
			table.insert(listA, {x = tmpEntry.x, y = tmpEntry.y + 1})
		end
		if checkTile({x = tmpEntry.x - 1, y = tmpEntry.y}, resType, listA, listB) == true then
			table.insert(listA, {x = tmpEntry.x - 1, y = tmpEntry.y})
		end
		if checkTile({x = tmpEntry.x + 1, y = tmpEntry.y}, resType, listA, listB) == true then
			table.insert(listA, {x = tmpEntry.x + 1, y = tmpEntry.y})
		end
		if checkTile({x = tmpEntry.x + 1, y = tmpEntry.y + 1}, resType, listA, listB) == true then
			table.insert(listA, {x = tmpEntry.x + 1, y = tmpEntry.y + 1})
		end
		if checkTile({x = tmpEntry.x - 1, y = tmpEntry.y - 1}, resType, listA, listB) == true then
			table.insert(listA, {x = tmpEntry.x - 1, y = tmpEntry.y - 1})
		end
		if checkTile({x = tmpEntry.x + 1, y = tmpEntry.y - 1}, resType, listA, listB) == true then
			table.insert(listA, {x = tmpEntry.x + 1, y = tmpEntry.y - 1})
		end
		if checkTile({x = tmpEntry.x - 1, y = tmpEntry.y + 1}, resType, listA, listB) == true then
			table.insert(listA, {x = tmpEntry.x - 1, y = tmpEntry.y + 1})
		end
	end

	return listB
end


function checkTile(pos, resType , listA, listB)
	local tmpTile = game.findentitiesfiltered{area = {pos, pos}, name = resType}
	if tmpTile[1] ~= nil then
		if not inList(pos, listA) and not inList(pos, listB) then
			return true
		end
	else
		return false
	end
end


function inList(pos, list)
	for _, listTile in ipairs(list) do
		if (listTile.x == pos.x) and (listTile.y == pos.y) then
			return true
		end
	end
	return false
end


function isInSolidList(resourcecategory)
	for _, category in ipairs (glob.resourceMonitor.resourceSolidList) do
		if resourcecategory == category then
			return true
		end
	end
	return false
end

function isInLiquidList(resourcecategory)
	for _, category in ipairs (glob.resourceMonitor.resourceLiquidList) do
		if resourcecategory == category then
			return true
		end
	end
	return false
end

function formatAmount(amount)
	local tmp = amount
	local result = ""
	while (string.len(tmp) > 3) do
		result = "." ..string.sub(tmp, -3) .. result
		tmp = math.floor(tmp / 1000)
	end

	if tmp ~= 0 then
		result = tmp .. result
	end
	return result
end


function startingItems()
	game.player.insert{name="iron-plate", count=8}
	game.player.insert{name="basic-bullet-magazine", count=100}
	game.player.insert{name="wooden-chest", count=64}
	game.player.insert{name="small-electric-pole", count=32}
	game.player.insert{name="basic-inserter", count=64}
	game.player.insert{name="solar-panel", count=54}
	game.player.insert{name="basic-transport-belt", count=128}
	game.player.insert{name="steam-engine", count=16}
	game.player.insert{name="boiler", count=32}
	game.player.insert{name="pipe", count=64}
	game.player.insert{name="basic-mining-drill", count=32}
	game.player.insert{name="basic-transport-belt-to-ground", count=32}
	game.player.insert{name="pipe-to-ground", count=32}
	game.player.insert{name="basic-splitter", count=32}
	game.player.insert{name="straight-rail", count=32}
	game.player.insert{name="curved-rail", count=32}
	game.player.insert{name="raw-wood", count=128}
	game.player.insert{name="car", count=1}
	game.player.insert{name="stone", count=256}
	game.player.insert{name="offshore-pump", count=8}
	game.player.insert{name="poison-capsule", count=8}
	game.player.insert{name="resource-monitor", count=2}

	game.player.force.technologies["resource-monitoring"].researched = true
end

remote.addinterface("resource-monitor-mod",
{
	addResource = function(newCategory, type)
		if type == "solid" then
			for _, category in ipairs (glob.resourceMonitor.resourceSolidList) do
				if category == newCategory then
					return false
				end
			end
			table.insert(glob.resourceMonitor.resourceSolidList, newCategory)
			return true
		elseif type == "liquid" then
			for _, category in ipairs (glob.resourceMonitor.resourceLiquidList) do
				if category == newCategory then
					return false
				end
			end
			table.insert(glob.resourceMonitor.resourceLiquidList, newCategory)
			return true
		else
			return false
		end
	end,

	resetGUI = function()
		glob.resourceMonitor.flags.MonitorVisible = 0
		glob.resourceMonitor.flags.AdderVisible = 0
		glob.resourceMonitor.flags.SettingsVisible = 0

		if game.player.gui.left.monitorFrame ~= nil then
			game.player.gui.left.monitorFrame.destroy()
		end

		if game.player.gui.left.rootAddingFrame ~= nil then
			game.player.gui.left.rootAddingFrame.destroy()
		end

		if game.player.gui.left.rootOilAddingFrame ~= nil then
			game.player.gui.left.rootOilAddingFrame.destroy()
		end

		if game.player.gui.left.rootSettingsFrame ~= nil then
			game.player.gui.left.rootSettingsFrame.destroy()
		end
	end
})